package ap.parser

import ap.terfor.{ConstantTerm, TermOrder}
import ap.parameters.{PreprocessingSettings, Param}

/**
 * Preprocess an InputAbsy formula in order to make it more suitable for
 * proving
 */
object Preprocessing {
  
  class PreprocessingException(msg : String) extends Exception(msg)

  def apply(f : IFormula,
            uniConstants : Set[ConstantTerm],
            order : TermOrder,
            settings : PreprocessingSettings)
                   : (IFormula, Set[ConstantTerm], TermOrder) = {
    val f2 = EquivExpander(f)
    val functionEncoder = new FunctionEncoder
    val (f3, order3) = functionEncoder(f2, order)
    val f4 = functionEncoder.axioms --> f3
    val f5 = Param.CLAUSIFIER(settings) match {
      case Param.ClausifierOptions.None => f4
      case Param.ClausifierOptions.Simple => SimpleClausifier(f4)
    }
    (f5, uniConstants, order3)
  }
  
}
