package ap.proof.goal;

import ap.basetypes.HeapCollector
import ap.terfor.ConstantTerm

object TaskInfoCollector {
  
  val EMPTY : TaskInfoCollector = new TaskInfoCollector(Set.empty, false)
  
}

class TaskInfoCollector private (val constants : Set[ConstantTerm],
                                 val containsLazyMatchTask : Boolean)
      extends HeapCollector[Task, TaskInfoCollector] {

  def +(task : Task, otherInfos : TaskInfoCollector) : TaskInfoCollector = {
    val taskConstants = task match {
                          case task : FormulaTask => task.formula.constants
                          case _ => Set.empty 
                        }
    new TaskInfoCollector(this.constants ++ taskConstants ++ otherInfos.constants,
                          this.containsLazyMatchTask ||
                            task.isInstanceOf[LazyMatchTask] ||
                            otherInfos.containsLazyMatchTask)
  }
  
}
