package ap.proof.goal

import ap.proof.tree.{ProofTree, ProofTreeFactory}
import ap.terfor.conjunctions.Conjunction

class UpdateConstantFreedomTask(newConstantFreedom : ConstantFreedom,
                                age : Int) extends PrioritisedTask {

  val priority : Int = -40000 + age
  
  def updateTask(goal : Goal, factCollector : Conjunction => unit)
                : Seq[PrioritisedTask] = List(this)

  def apply(goal : Goal, ptf : ProofTreeFactory) : ProofTree = {
    val (newTasks, newCompoundFormulas) =
      goal.compoundFormulas.updateConstantFreedom(newConstantFreedom, goal)
    val updatedVocabulary = goal.vocabulary updateConstantFreedom newConstantFreedom

    ptf.updateGoal(newCompoundFormulas, newTasks, updatedVocabulary, goal)
  }
  
  override def toString = "UpdateConstantFreedomTask(" + priority + ")"
}
